<template>
    <div>
        <PlaceholderField :placeholder="placeholder" />
        <input
            v-model="textValue"
            :type="type"
            min="0"
            :placeholder="placeholder"
            :autocomplete="autocomplete"
            :autofocus="autofocus"
            aria-label="none"
            :disabled="disabled"
        />
        <ErrorsField :errors="locErrors" />
    </div>
</template>

<script>
import ErrorsMixin from "@/mixins/errorsMixin";
import ErrorsField from "@/components/ErrorsField";
import PlaceholderField from "@/components/PlaceholderField";

export default {
    name: "QuestTextField",
    components: { PlaceholderField, ErrorsField },
    props: {
        value: [Number, String],
        placeholder: { type: String, default: "" },
        autocomplete: { type: String, default: "" },
        password: Boolean,
        email: Boolean,
        autofocus: Boolean,
        readonly: Boolean,
        disabled: Boolean,
    },
    mixins: [ErrorsMixin],
    computed: {
        textValue: {
            get() {
                return String(this.value);
            },
            set(value) {
                if (!this.readonly || this.value === null)
                    this.$emit("input", String(value));
            },
        },
        type() {
            return this.password ? "password" : this.email ? "email" : "text";
        },
    },
    watch: {
        value: {
            immediate: true,
            handler(v) {
                this.$input();
                if (v === null) this.textValue = "";
            },
        },
    },
};
</script>

<style scoped></style>
